module Cheat
where

import StrategyOptimization
import PaperRockScissors

-------------------------------------------------------
-- Funktion mit der man schummeln kann
-------------------------------------------------------
cheat :: Strategy
cheat xs 	= map trumps xs

-------------------------------------------------------
-- Funktion, die prinzipiell wie cheat arbeitet, aber 
-- bei Eingabe von bottom wird eine Liste geliefert
-------------------------------------------------------
cunning :: Strategy
cunning xs = trumps (head xs) : cunning (tail xs)

-------------------------------------------------------
-- Hier wird nur im ersten Spiel geschummelt
-------------------------------------------------------
oneshot :: Strategy
oneshot xs = trumps (head xs) : recipro (tail xs)

-------------------------------------------------------
-- Die Ersten zwei Spiele sind fair, alle anderen Spiele
-- sind geschummelt
-------------------------------------------------------
devious :: Strategy
devious xs = take 2 (recipro xs) ++ cheat (drop 2 xs)

-------------------------------------------------------
-- Funktion die zu einem Zug jeweils den gewinnenden
-- Zug berechnet
-------------------------------------------------------
trumps :: Move -> Move
trumps Paper	= Scissors
trumps Rock		= Paper
trumps Scissors	= Rock