module MatchOptimizationPolice
where

import StrategyOptimization
import Match
import PaperRockScissors
import Cheat

-------------------------------------------------------
-- Liefert eine Liste von Runden, die aus den Strategien
-- berechnet werden
-------------------------------------------------------
rounds :: (Strategy, Strategy) -> [Round]
rounds (f, g) =	zip xs ys
		where
		xs = police f ys
		ys = police g xs

-------------------------------------------------------
-- Durch das festlegen von zwei Strategien im Strategy-
-- Tupel und einem Int-Wert, der die Anzahl der Runden
-- angibt, knnen mehrere Spielrunden gesplielt werden
-------------------------------------------------------
match :: Int -> (Strategy, Strategy) -> (Int, Int)
match n = total . map score . take n . rounds

-------------------------------------------------------
-- Funktion zur Ueberpruefung, ob die Strategie
-- schummelt
-------------------------------------------------------
police :: Strategy -> [Move] -> [Move]
police f xs = ys where ys = f (synch xs ys)

-------------------------------------------------------
-- Mit dieser Funktion weredn zwei Zug-Listen synchron-
-- isiert
-------------------------------------------------------
synch :: [Move] -> [Move] -> [Move]
synch (x : xs) (y : ys)	= if (defined y)
			   			  then x : synch xs ys
						  else undefined
						  
-------------------------------------------------------
-- Ueberpruefung, ob ein Zug definiert ist
-------------------------------------------------------						  
defined :: Move -> Bool
defined Paper    = True
defined Rock     = True
defined Scissors = True
defined x = False


