module MatchSimple
where

import StrategySimple
import Match
import PaperRockScissors

-------------------------------------------------------
-- Durch das festlegen von zwei Strategien im Strategy-
-- Tupel und einem Int-Wert, der die Anzahl der Runden
-- angibt, knnen mehrere Spielrunden gesplielt werden
-------------------------------------------------------
match :: Int -> (Strategy, Strategy) -> (Int, Int)
match n = total . map score . take n . rounds

-------------------------------------------------------
-- Liefert eine Liste von Runden, die aus den Strategien
-- berechnet werden
-------------------------------------------------------
rounds :: (Strategy, Strategy) -> [Round]
rounds (f, g) = (map last . tail . iterate (extend (f, g))) []

-------------------------------------------------------
-- Die Funktion haengt an eine RundenListe eine neue
-- Runde an, die mit Hilfe der Strategien ermittelt 
-- werden und gibt eine neue Rundenliste aus
-------------------------------------------------------
extend :: (Strategy, Strategy) -> [Round] -> [Round]
extend (f, g) rs = rs ++ [(f (map snd rs), g (map fst rs))]


