module Strategy
where

import PaperRockScissors
import System.Random

-------------------------------------------------------
-- Berechnung eines Int-Tripels zur Bestimmung der
-- einzelnen unterschiedlichen Zuege
-------------------------------------------------------
(+++) :: (Int, Int, Int) -> Move -> (Int, Int, Int)
(p, r, s) +++ Paper	= (p+1, r, s)
(p, r, s) +++ Rock	= (p, r+1, s)
(p, r, s) +++ Scissors	= (p, r, s+1)

-------------------------------------------------------
-- Funktion zur Auswahl eines Zuges
-------------------------------------------------------
choose :: (Int, Int, Int) -> Move
choose (p, r, s)
	| m < p		= Scissors
	| m < p + r	= Paper
	| otherwise	= Rock
	where m = random' (p+r+s)

-------------------------------------------------------
-- Generierung einer Zufallszahl
-------------------------------------------------------
random' :: Int -> Int
random' n = mod ((randomList n :: [Int]) !! (mod n 99)) n

-------------------------------------------------------
-- Generierung einer Zufallsliste
-------------------------------------------------------
randomList :: (Random a) => Int -> [a]
randomList seed = randoms (mkStdGen seed)

