module StrategySimple
where

import Strategy
import PaperRockScissors

type Strategy = [Move] -> Move

-------------------------------------------------------
-- Eine einfache, aber effiziente Implementierung ;)
-------------------------------------------------------
stupid :: Strategy
stupid ms = Rock

-------------------------------------------------------
-- Strategie, die den vorherigen Zug des Gegners wieder-
-- holt
-------------------------------------------------------
recipro :: Strategy
recipro ms 	= if null ms
		   then Rock
		   else last ms

-------------------------------------------------------
-- Strategie, die den naechsten Spielzug nach der 
-- Haeufigkeit, der getaetigten Spielzuege, berechnet
-------------------------------------------------------
smart :: Strategy
smart ms 	= if null ms
		   then Rock
		   else choose (count ms)

-------------------------------------------------------
-- Ausnutzung von foldl um die Anzahl der unterschied-
-- liche Spielzuege zu berechnen
-------------------------------------------------------
count :: [Move] -> (Int, Int, Int)
count = foldl (+++) (0, 0, 0)